/************************************************************************
*Copyright (C) 2003 Elliott Michell					*
*Elliott Mitchell takes no responsibility for failures, or damage done	*
*by this program.							*
*									*
*$Id$			*
*************************************************************************
*Absolutly pure RLE. Very simple encoding, every token is simply a	*
*count followed by the repeated byte.					*
*									*
*For the general case this is an extremely bad encoding scheme. For	*
*special cases though it works pretty well. In particular		*
*non-photorealistic graphics data this is moderatly effective. Anything	*
*else and the encoded data will likely be larger than the non-encoded	*
*data. This is simply here for completness.				*
************************************************************************/

#include <stdio.h>

int main(int argc, char **argv, char **envp)
{
	char *func;
	int tok, last, len;

	func=*argv+strlen(*argv);
	while(func[-1]!='/'&&func>*argv) --func;

	if(strcmp("unpurerle", func)) {
		tok=getchar();

		while(tok!=EOF) {
			len=0;
			last=tok;
			while((tok=getchar())==last) ++len;
			/*For *really* long runs, be aware len can overflow...*/
			while(len>255) {
				putchar(255);
				putchar(last);
				len-=256;
			}
			putchar(len);
			putchar(last);
		}
	} else {
		while((len=getchar())!=EOF) {
			if((tok=getchar())==EOF) break;
			++len;
			do putchar(tok); while(--len);
		}
	}
	return(0);
}

